function OnInit()

	this:SetVisualProfile("~/shopkeep.xml", "shopkeep");
	this:LoadCollisionInfo("~/shopkeep.col");
	this:SetDensity(1); --//control how hard he is to push.  0 would mean unpushable
	m_speechTimer = 0;
	this:SetCategory(C_CATEGORY_CHARACTER, true);
	this:SetCategory(C_CATEGORY_ENTITY, false);
end

function OnPostInit() --//only run after we're actually pasted in the world
	
	this:GetBrainManager():Add("StandardBase","");
	this:GetBrainManager():SendToBrainBase("control_filtery=0");
	this:GetBrainManager():SetStateByName("Idle");
	this:SetFacingTarget(C_FACING_RIGHT);
	this:SetCollisionListenCategory(C_CATEGORY_PLAYER, true);
	this:SetVisibilityNotifications(true); --//OnGetVisible and OnLoseVisible will get called now
	m_hp = 55;
	this:SetDefaultTalkColor(Color(150,255,255,255));
	
	
end


function OnGetVisible()
end

function OnLoseVisible() --//we left the screen

	--//let this entity function offscreen for a while
	GetWatchManager:Add(this, 1000*5); --//will call OnWatchTimeout(bIsOnScreen) when timed out if it exists
 
end

function OnFatherDialogResponse(text, key, dialog) --//dialog is passed as a SpecialEntity)

		if (key == "hi") then
	    
	        local goal = this:GetGoalManager():PushNewGoal("Talk");
			goal:AddSay("Not much.", g_playerID);
	    end

		if (key == "buy") then
		
			--//setup a store menu
			inventory = {};
			AddItem("red_potion", inventory);
			OnStoreBuyMenu(inventory, this, "_first_");
			
		end

end

function OnStoreEnd()
	--//store ended, start back up our conversation
	OpenDialogMenu("buy");
end

function OpenDialogMenu(defaultOption)
	
	if (defaultOption == "_first_") then
		PlayDialogOpenSound();
	end
	--//note, the [[ and ]] is a lua way to make defining long strings easier.  You don't have to use it, msg = "crap"; works too.
		local msg = "Shop";
	
	entChoice = CreateEntitySpecial("ChoiceDialog", "msg=" .. msg .. 
	";callback=OnFatherDialogResponse;title=Your Father;entity_id=" .. this:GetID()
	 .. ";selection=" .. defaultOption);
		
		entChoice:Send("add_choice|What's up?|hi");
		entChoice:Send("add_choice|View items for sale|buy");
		entChoice:Send("add_choice|Nevermind|back");
		entChoice:Send("activate");
end

function OnAction(ent)

	OpenDialogMenu("_first_");

end

function OnDamage(normal, depth, enemy, damage, userVar, projectile)

	pushVec = this:GetPos() - enemy:GetPos();
	pushVec:Normalize();

	this:AddForce(pushVec * damage*2);
	
	 if (m_hp <= 0) then
	 	--//already dead
	 	return;
 	end

	m_hp = m_hp - damage;
	GetTextManager:AddCustom(tostring(damage), this, this:GetPos(), Vector2(0, -0.3), Color(200,0,0,255), 2000, C_FONT_DEFAULT);
	this:GetBrainManager():Add("ColorFlash", "pulse_rate=200;g=-200;b=-200;remove_brain_by_pulses=1");
 
	if (m_hp <= 0) then
  --//kill it
	  
	else
		GetSoundManager:Play("audio/bug_attack.ogg");
	end

end  

--//vPosition, vVelocity and vNormal are Vector2's, depth and materialID are numbers, entity is a Entity, and state let's you know
--//if this is a first contact or a persisting one. (Don't worry about state for now, will add more later..)

--//if entity is nil, it is a collision with a TilePic

function OnCollision(vPosition, vVelocity, vNormal, depth, materialID, entity, state)

	 
  
return;
end

