--//setup our item database, called from game_start.lua

--//The way items work is there is a global table variable of each kind of item that is referenced by name - this is for the info
--//that doesn't change.

--//A players "inventory" is a lua table that contains the name of each item he owns (the specifics of which can then be referenced
--//from the global g_Items table) plus it contains any 'per-instance' data that is needed, like how many blasts of the magic
--//wand are left.

g_Items = {};

--//add the items we need in the game to our global database, happens once at the start

--//the "uses" variable should be 1 (one use) or not defined (which would means unlimited/na).

g_Items.red_potion = {name = "Red Potion", description = "Restores 20 health", value=10, use_action = "Drink", power=25, group="items"};
g_Items.damaged_claw = {name = "Damaged Claw", value=2, group="items"};
g_Items.claw = {name = "Claw", value=4, group="items"};
g_Items.short_sword = {name = "Short Sword", description = "Damage 5", value=10, use_action = "Equip", power=5, group="weapons"};
g_Items.firesword = {name = "Fire Sword", description = "Damage 10", value=10, use_action = "Equip", power=10, group="weapons"};
g_Items.spark = {name = "Spark", description = "A simple electrical spell.", value=10, use_action = "Equip", power=5, group="magic"};

--//some general functions to make dealing with items easier

function AddItem(itemName, inventory)

	--//push to the front
	table.insert(inventory, 1, {item = itemName});
	--//Dump(inventory);
end

function RemoveItemByIndex(inventory, indexID)
	table.remove(inventory, indexID);
end

--//special handing for items that do stuff

function red_potion_action(playerItem, playerItemPower)

	GetSoundManager:Play("audio/effects/gulp.ogg");
	GetPlayer:RunFunction("OnHeal", playerItemPower);
	return "return_to_menu";
end

function equipme(playerItem, playerItemPower)

	GetPlayer:RunFunction("OnEquip", playerItem, playerItemPower);
	GetSoundManager:Play("audio/effects/swordraw.ogg");
	return "return_to_menu";

end

function equipspell(playerItem, playerItemPower)

	GetPlayer:RunFunction("SpellEquip", playerItem, playerItemPower);
	GetSoundManager:Play("audio/effects/swordraw.ogg");
	return "return_to_menu";

end
