RunScript("system/player_utils.lua"); --//has some useful global functions, this is in base

function SetDefaults()

--//entity stuff
	this:SetCategory(C_CATEGORY_ENTITY, false);
	this:SetCategory(C_CATEGORY_PLAYER, true);
	this:SetCollisionListenCategory(C_CATEGORY_TILEPIC, true);
	this:SetCollisionListenCategory(C_CATEGORY_ENTITY, true);
	this:GetBrainManager():Add("StandardBase","");
	this:GetBrainManager():SendToBrainBase("control_filtery=0");
	

--//movement stuff
	--//run
	this:SetDensity(.36);
	m_walkSpeed = 8;
	this:SetDesiredSpeed(m_walkSpeed);
	this:SetTurnSpeed(10);
	m_lastDirection = C_FACING_RIGHT;	
	--//climb
	m_climbSpeed = 5;
	m_ladderSensitivity = 10;
	m_bOnLadder = false;	
	--//jump
	m_JumpPower = -8;
	m_JumpMultiplier = 2.5;
	m_delayBetweenJumpsMS = 200;
	m_timeToControlJumpHeightMS = 400;
	m_jumpTimer = 0;
	m_airjumpTimer = 0;
	m_isJumping = true;
	m_jumpSfxTimer = 0;
	m_jumpSfxMinTimeBetweenSoundsMS = 150;
	m_bJumpKeyDown = false;	
	--//attack
	m_delayBetweenAttacksMS = 500;
	m_attackTimer = 0;	
	--//turn off door check
	m_bCheckForDoor = false;
	
--//stats and stuff
	this:Data():SetIfNull("coins", "0");
	m_invincibilityTimer = 0;
	m_max_hp = this:Data():SetNumIfNull("max_hp", 100);
	m_hp = this:Data():SetNumIfNull("hp", this:Data():GetNum("max_hp"));
	
	m_max_mp = this:Data():SetNumIfNull("max_mp", 100);
	m_mp = this:Data():SetNumIfNull("mp", 100);
	
	HasArmor = this:Data():SetIfNull("HasArmor", "tank_girl");
	HasWeapon = this:Data():SetIfNull("HasWeapon", "none");
	WeaponDamage = this:Data():SetNumIfNull("WeaponDamage", 0);
	HasSpell = this:Data():SetIfNull("HasSpell", "none");
	SpellCost = this:Data():SetNumIfNull("SpellCost", 0);
	this:SetDefaultTalkColor(Color(255,255,150,255)); --//do we need this?
	
	m_inventory = unserialize_from_db("inventory", this:Data()); --//will return a blank table if nothing exists
	
--//sound	moved to init to stop editor from crashing on exit
	--//m_jumpSound = "audio/jump.wav";
	--//m_walkLoopingSound = LoopingSound("audio/walk_loop2.ogg");
	--//m_climbLoopingSound = LoopingSound("audio/climb_loop2.ogg");	

--//restes keys, duh
	ResetKeys()
end

function SetupInputKeys()

--//keyboard
	--//movement
	GetInputManager:AddBinding("a,always", "OnLeft", this:GetID());
	GetInputManager:AddBinding("d,always", "OnRight", this:GetID());
	GetInputManager:AddBinding("w,always", "OnUp", this:GetID());
	GetInputManager:AddBinding("s,always", "OnDown", this:GetID());
	--//actions
	GetInputManager:AddBinding("control", "OnAttackButton", this:GetID());
	GetInputManager:AddBinding("shift", "OnAttack2Button", this:GetID());
	GetInputManager:AddBinding("e,always", "OnActionButton", this:GetID());
	GetInputManager:AddBinding("space,always", "OnJumpButton", this:GetID());

--//joystick
	--//movement
	GetInputManager:AddBinding("joy_any_left,always", "OnLeft", this:GetID());
	GetInputManager:AddBinding("joy_any_right,always", "OnRight", this:GetID());
	GetInputManager:AddBinding("joy_any_up,always", "OnUp", this:GetID());
	GetInputManager:AddBinding("joy_any_down,always", "OnDown", this:GetID());
	--//actions
	GetInputManager:AddBinding("joy_any_button_3", "OnAttackButton", this:GetID());
	GetInputManager:AddBinding("joy_any_button_1", "OnAttack2Button", this:GetID());
	GetInputManager:AddBinding("joy_any_button_0", "OnActionButton", this:GetID());
	GetInputManager:AddBinding("joy_any_button_2", "OnJumpButton", this:GetID());	

end

--//check for pressed buttons
function OnLeft(bKeyDown)

	m_bLeft = bKeyDown;
	return true;
end

function OnRight(bKeyDown)

	m_bRight = bKeyDown;
	return true;
end

function OnDown(bKeyDown)

	m_bDown = bKeyDown;
	return true;
end

function OnUp(bKeyDown)

	m_bUp = bKeyDown; 
	
	if (m_bOnLadder == false and m_bUp and this:GetOnGround()) then
		m_bCheckForDoor = true;		
	end
	
	return true;
end

function OnAttackButton(bKeyDown)

	if (bKeyDown) then
	
		if (m_attackTimer < GetApp:GetGameTick()) then
			m_bAttack = true;
			m_attackTimer = GetApp:GetGameTick() + m_delayBetweenAttacksMS;
		end
	end	
	
	return true; 	
end

function OnAttack2Button(bKeyDown)

	if (bKeyDown) then
	
		if (m_attackTimer < GetApp:GetGameTick()) then
			m_bAttack2 = true;
			m_attackTimer = GetApp:GetGameTick() + (m_delayBetweenAttacksMS*2);
		end
	end	
	
	return true; 	
end

function OnActionButton(bKeyDown)

	if (bKeyDown) then
		m_bAction = true;
	end
	
	return true;
end

function OnJumpButton(bKeyDown)
	m_bJump = bKeyDown;
	return true; 	
end



function ResetKeys()

	m_bLeft = false;
	m_bRight = false;
	m_bUp = false
	m_bDown = false;
	
	m_bAttack = false;
	m_bAttack2 = false;
	m_bAction = false;
	m_bJump = false;
	
end
--//end of button stuff

function OnInit()
	
	this:SetVisualProfile("~/tank_girl.xml", "tank_girl");
	this:LoadCollisionInfo("~/tank_girl.col");
	m_jumpSound = "audio/jump.wav";
	m_walkLoopingSound = LoopingSound("audio/walk_loop2.ogg");
	m_climbLoopingSound = LoopingSound("audio/climb_loop2.ogg");

end

function OnPostInit()

	this:SetName("Player");
	SetDefaults();
	this:SetVisualProfile("~/"..HasArmor..".xml", "tank_girl");
	SetupInputKeys();
	Startup();
	MakePaperDoll();
	this:SetRunUpdateEveryFrame(true);
	if (HasWeapon != "none") then
		m_doll:RunFunction("ChangeWeapon", HasWeapon, WeaponDamage);
	end
	
end

function GetHP()
	return m_hp;
end

function GetMaxHP()
	return m_max_hp;
end

function GetMP()
	return m_mp;
end

function GetSpell()
	return HasSpell;
end

function GetMaxMP()
	return m_max_mp;
end

function GetInventory()
	return m_inventory;
end

function MakePaperDoll()

	--//m_doll = CreateEntity(this:GetMap(), this:GetPos(), "weapons/"..HasWeapon.."/"..HasWeapon..".lua");
	--//m_doll:RunFunction("SetParent", this);
	--//m_fspeed:RunFunction("SetParent", this);
	m_doll = CreateEntity(this:GetMap(), this:GetPos(), "weapons/paper_doll.lua");
	m_doll:SetAttach(this:GetID(), Vector2(0,0));
	m_doll:SetLayerByName("Overlay 1");

end

function Startup()

	if (GameIsActive()) then

		LogMsg("Initializing the player entity.");
		UpdateGUI();

		--//this is a real game, not the editor
		if (this:Data():Exists("firsttime") == false) then

			this:Data():SetNum("firsttime", 1);
			--//GiveItem("test_sword");
			
			Schedule(1000, C_ENTITY_NONE,
				'GetTextManager:AddCustomScreen("Use W A S and D to move and climb.", Vector2(C_SCREEN_X/2,C_SCREEN_Y-20), Vector2(0, 0), Color(200,200,0,255), 4000, C_FONT_DEFAULT);');
			Schedule(6000, C_ENTITY_NONE,
				'GetTextManager:AddCustomScreen("Press Space to jump.", Vector2(C_SCREEN_X/2,C_SCREEN_Y-20), Vector2(0, 0), Color(200,200,0,255), 4000, C_FONT_DEFAULT);');
			Schedule(11000, C_ENTITY_NONE,
				'GetTextManager:AddCustomScreen("Press Ctrl to attack.", Vector2(C_SCREEN_X/2,C_SCREEN_Y-20), Vector2(0, 0), Color(200,200,0,255), 3500, C_FONT_DEFAULT);');
			Schedule(16000, C_ENTITY_NONE,
				'GetTextManager:AddCustomScreen("Press E to inspect things.", Vector2(C_SCREEN_X/2,C_SCREEN_Y-20), Vector2(0, 0), Color(200,200,0,255), 3500, C_FONT_DEFAULT);');
		end
	end

end	
--//this is run every logic tick

function Update(step)
	
	AssignPlayerToCameraIfNeeded(this);
	GetCamera:SetLimitToMapArea(true);
	
	
	if (this:GetGoalManager():GetGoalCount() == 0) then
		
		ProcessLadder();
		
		if (m_bOnLadder == false) then
			
			if (this:GetBrainManager():InState("Attack") == false and this:GetBrainManager():InState("Attack2") == false) then
				ProcessMovement(step);
		
				if (m_bAction) then	ProcessAction(); end;
				if (m_bAttack) then	ProcessAttack(); end;
				if (m_bAttack2) then ProcessSpell(); end;
				if (m_bJump) then ProcessJump(); end;
				if (m_bCheckForDoor) then ProcessDoor(); m_bCheckForDoor = false; end;
											
			end
		else		
				ProcessMovementLadder(step);
		end
			
	else
		--//we're in a cut scene.  Maybe we should letter box or show a "In cutscene, hold TAB to speed up"?
		if (this:GetBrainManager():InState("Pain") == false ) then
			m_doll:GetBrainManager():SetStateByName("Idle");
		end
	end
	
	m_doll:RunFunction("SyncAnims", this);
	
	UpdateSounds();
	
end

function UpdateGUI()
	
	--//tell the interface GUI bar to update everything ASAP
	if (GetEntityByID(g_interfaceID)) then
		GetEntityByID(g_interfaceID):RunFunction("RequestUpdate");
	end
end

function UpdateSounds()

	if (this:GetLinearVelocity():Length() < 0.3 or (this:GetOnGround() == false and m_bOnLadder == false)) then
		--//not moving fast enough to want to play a walk/climb sound, or else they are not on the ground or
		--//a ladder, so we assume they are falling or something and no sound should be played
		
		m_walkLoopingSound:Play(false);	
		m_climbLoopingSound:Play(false);	
	else

	   --//well, we need to play a sound.  But which one?
	   
	   if (m_bOnLadder) then
			m_walkLoopingSound:Play(false);	
			m_climbLoopingSound:Play(true);	
	   else 
			if (m_bRight or m_bLeft) then
				m_walkLoopingSound:Play(true);	
				m_climbLoopingSound:Play(false);	
			else
				m_walkLoopingSound:Play(false);	
				m_climbLoopingSound:Play(false);	
			end
	   end
	
	end

end

function ProcessMovement(step)

	local facing = C_FACING_NONE;	
	if (m_bLeft) then facing = C_FACING_LEFT; end	
	if (m_bRight) then facing = C_FACING_RIGHT;	end
	
		if (this:GetOnGround() and m_airjumpTimer < GetApp:GetGameTick() ) then
		this:SetVisualStateOverride(C_VISUAL_STATE_NONE);
		m_doll:SetVisualStateOverride(C_VISUAL_STATE_NONE);
		--check for a is-jumping flag here..
		if (m_isJumping == true) then
			m_jumpTimer = GetApp:GetGameTick()+m_delayBetweenJumpsMS;
			m_isJumping = false;
			m_bJump = false;
		end
	else
  		this:SetVisualStateOverride(C_VISUAL_STATE_JUMP);
		m_doll:SetVisualStateOverride(C_VISUAL_STATE_JUMP);
	end
	
	if (facing != C_FACING_NONE) then
		
		--//they are pressing towards a direction
		this:SetFacingTarget(facing); --//turn the way we want
		this:GetBrainManager():SetStateByName("Walk");
		
		m_doll:GetBrainManager():SetStateByName("Walk");
		
		m_lastDirection = facing; --//store this for later, like when we get off the ladder
	else
		if (HasWeapon != "none") then
			this:GetBrainManager():SetStateByName("Special1");
			m_doll:GetBrainManager():SetStateByName("Special1");
			
		else
		
		this:GetBrainManager():SetStateByName("Idle");
		m_doll:GetBrainManager():SetStateByName("Idle");
		
		end
	end
	
end

function ProcessMovementLadder(step)

	 this:SetOnGround(true);  --//we're actually floating in space as far as the game is concerned, this tells it to
	 --//treat us like we're on the ground

	--//check for movement
	local facing = C_FACING_NONE;

	if (m_bUp) then facing = C_FACING_UP; end;
	if (m_bDown) then facing = C_FACING_DOWN; end;

	if (facing != C_FACING_NONE) then
		this:GetBrainManager():SetStateByName("Walk");
		this:SetAnimPause(false);
		--//why not slightly center them on the ladder as well?  So they don't fall off it it kind of curves around.
		local vFeetPos = Vector2(this:GetPos().x, this:GetWorldCollisionRect().bottom);

		local z = this:GetNearbyZoneByMaterialType(vFeetPos, C_MATERIAL_TYPE_VERTICAL_LADDER);
		
		if (z.materialID ==  C_MATERIAL_VERTICAL_LADDER) then
			local ladderCenterX = z.vPos.x + (z.boundingRect:GetWidth()/2) + z.boundingRect.left;
			--//LogMsg("ladder x is " .. ladderCenterX .. " rect: " ..tostring(z.boundingRect));
			this:SetPos(Vector2(Lerp(this:GetPos().x, ladderCenterX, 0.1*step), this:GetPos().y));
	
		end
		
			this:SetFacingTarget(facing); --//point up or down
		
		else
			--//we're sitting here on a ladder doing nothing, just pause the active animation
			this:GetBrainManager():SetStateByName("Idle");
			this:SetAnimPause(true);
	end	
end

function ProcessLadder()

	--//first, the point we should use to determine if we're standing on a ladder should be our FEET (well, bottom
	--//of the collision rect), not the middle of the entity like normal.  Here's how we can get that.
	
	local vFeetPos = this:GetPos();
	vFeetPos.y = this:GetWorldCollisionRect().bottom;
	
	--//LogMsg("Foot point is at " .. tostring(vFeetPos));

	if (m_bOnLadder == false) then
		
		if (m_bUp) then
			if (this:InNearbyZoneByMaterialType(vFeetPos - Vector2(0, m_ladderSensitivity), C_MATERIAL_TYPE_VERTICAL_LADDER)) then
				this:AddForce(Vector2(0, -5));
				EnterLadderMode();
			end
		elseif (m_bDown) then
				--//is there a ladder going down?
				if (this:InNearbyZoneByMaterialType(vFeetPos, C_MATERIAL_TYPE_VERTICAL_LADDER)
				and this:InNearbyZoneByMaterialType(vFeetPos + Vector2(0, m_ladderSensitivity), C_MATERIAL_TYPE_VERTICAL_LADDER)) then
				EnterLadderMode();
				end
		end
	
	else
		--//player is currently in ladder mode.  Time to end it or not?  Let's make it so they can hold diagonal without
		--//leaving ladder mode, makes it 'feel' a bit better
		
		if (this:InNearbyZoneByMaterialType(vFeetPos, C_MATERIAL_TYPE_VERTICAL_LADDER) == false
		or ( (m_bLeft or m_bRight) and (m_bUp == false and m_bDown == false)) ) then
			EndLadderMode();	
		end
	
	end

end

function EnterLadderMode()

	--//setup for ladder mode
	this:GetBrainManager():SendToBrainBase("control_filtery=1"); --//turn Y dampening/movement back on
	this:SetGravityOverride(0);
	this:GetBrainManager():Add("ForceVisual", "force_anim=climb"); --//look like we're climbing, even
	m_doll:GetBrainManager():Add("ForceVisual", "force_anim=climb"); --//look like we're climbing, even
	this:SetDesiredSpeed(m_climbSpeed);
	this:SetCollisionCategories(C_CATEGORIES_NONE); --//don't collide with anything
	m_bOnLadder = true;
			
end

function EndLadderMode()

	if (m_bOnLadder == false) then return; end;

	this:GetBrainManager():SendToBrainBase("control_filtery=0"); --//turn Y dampening/movement back off
	this:SetGravityOverride(C_GRAVITY_OVERRIDE_DISABLED); --//turn gravity back on
	this:GetBrainManager():Remove("ForceVisual"); --//all "ForceVisual" brains are removed
	m_doll:GetBrainManager():Remove("ForceVisual"); --//all "ForceVisual" brains are removed
	this:SetAnimPause(false); --//make sure we're not still paused
	m_bOnLadder = false;
	m_bAttack = false;
	this:SetOnGround(false); --//we might not be..
	this:SetFacingTarget(m_lastDirection); --//don't want to keep pointing up or down
	this:SetDesiredSpeed(m_walkSpeed);
	this:SetCollisionCategories(C_CATEGORIES_ALL); --//collide with everything again

		
end

function ProcessDoor()

	local z = this:GetActiveZoneByMaterialType(C_MATERIAL_TYPE_WARP);
	
	if (z.entityID != C_ENTITY_NONE) then
		
		--//warp found
		local warpEnt = GetEntityByID(z.entityID);
		
		--//use an offset so we end up with our FOOT on the destination spot, instead of our true center
		local vOffset = Vector2(0, -(this:GetCollisionRect():GetHeight()/2));
		warpEnt:RunFunction("OnWarp", this, vOffset);
		
	end

end

function ProcessJump()

		if (this:GetOnGround() and m_jumpTimer < GetApp:GetGameTick() and m_isJumping == false) then
			m_isJumping = true;
			m_airjumpTimer = GetApp:GetGameTick()+m_timeToControlJumpHeightMS;
			this:StopY();
			this:AddForce(Vector2(0, m_JumpPower));
			this:PlaySound(m_jumpSound);
		
		elseif (m_isJumping == true and m_airjumpTimer > GetApp:GetGameTick() ) then
			this:AddForceConstant(Vector2(0, (m_JumpPower * m_JumpMultiplier)));
		end

end



function ProcessAttack()

	if (HasWeapon != "none") then
	
	this:SetVisualStateOverride(C_VISUAL_STATE_NONE); --//same as above but faster
	m_doll:SetVisualStateOverride(C_VISUAL_STATE_NONE);
	
	this:GetBrainManager():SetStateByName("Attack");	
	m_doll:GetBrainManager():SetStateByName("Attack");
	

	m_doll:SetCollisionListenCategory(C_CATEGORY_ENEMY, true);
	m_doll:SetCollisionListenCategory(C_CATEGORY_ENTITY, true);
	Schedule(1, m_doll:GetID(), "m_canHit = true;");
	GetSoundManager:Play("audio/effects/swing.ogg");
	
	else
		GetTextManager:Add("I don't have a weapon yet!", this);
		
	end
	
	m_bAttack = false;
end

function OnAttackLoop() --//this is called when the Attack state animation reaches the end/looping point
	--//attack animation is done, switch to another state
	this:GetBrainManager():SetStateByName("Idle");
	this:SetAnimFrame(0);
end

function ProcessSpell()

	if (HasSpell != "none") then
	
		if (m_mp >= SpellCost) then
	
			this:SetVisualStateOverride(C_VISUAL_STATE_NONE); --//same as above but faster
			m_doll:SetVisualStateOverride(C_VISUAL_STATE_NONE);
	
			this:GetBrainManager():SetStateByName("Attack2");	
			m_doll:GetBrainManager():SetStateByName("Attack2");
			Schedule(300, this:GetID(), "CastSpell()");
		end
	
	else
		GetTextManager:Add("I don't have a spell yet!", this);
		
	end
	
	m_bAttack2 = false;
end

function CastSpell()

	local ent = CreateEntity(this:GetMap(), this:GetPos() + (FacingToVector(this:GetFacing()) * 64 + Vector2(0,-16)), "spells/"..HasSpell.."/"..HasSpell..".lua");
	ent:RunFunction("SetParent", this);
	m_mp = m_mp - (SpellCost -4);
	UpdateGUI();

end

function OnAttack2Loop() --//this is called when the Attack state animation reaches the end/looping point
	--//attack animation is done, switch to another state
	this:GetBrainManager():SetStateByName("Idle");
	this:SetAnimFrame(0);
end


function OnCollision(vPosition, vVelocity, vNormal, depth, materialID, entity, state)

--//LogMsg("Player touching material", materialID);
if (m_bOnLadder or GetMaterialManager:GetMaterial(materialID):GetType() != C_MATERIAL_TYPE_NORMAL) then 
		return; --//only bump our heads on hard things, not ladder zones and such
	end

	--//LogMsg("Hit Static: Depth: " .. tostring(depth) .. " normal: " .. tostring(vNormal));

if (vNormal.y > 0.8 and depth > 0.005 and depth < 0.1) then

	--//They hit their head on a static wall
	if (m_jumpSfxTimer < GetApp:GetGameTick()) then
		GetSoundManager:Play("audio/mario/bump.wav");
		--//Set timer so we won't play it again too soon
		m_jumpSfxTimer = GetApp:GetGameTick() + m_jumpSfxMinTimeBetweenSoundsMS;
		end
	else
	 --//well, we know they didn't bump their head.
	 --//if we wanted to see if they were touching the floor, or had just hit a side wall, we'd do it here.
	end

end

function OnDamage(normal, depth, enemy, damage, userVar, projectile)
	 
	if (m_invincibilityTimer != 0) then
		if (m_invincibilityTimer > GetApp:GetGameTick()) then
			--//we can't be hurt yet
			return;
		 else
			m_invincibilityTimer = 0; --//not invincible anymore
		 end
	end
	 
		GetTextManager:AddCustom(tostring(damage), this, this:GetPos(), Vector2(0, -0.3), Color(200,0,0,255), 2000, C_FONT_DEFAULT);
  
  		--//GetTextManager:Add("Ouch!", this);
  		GetSoundManager:Play("audio/player/pain" .. math.random(3) .. ".ogg");

		this:GetBrainManager():Add("ColorFlash", "pulse_rate=200;g=-200;b=-200;remove_brain_by_pulses=1");

		--//make them fall off the ladder if they were on it.
		EndLadderMode();
 
		this:SetVisualStateOverride(C_VISUAL_STATE_NONE); --//same as above but faster
		m_doll:SetVisualStateOverride(C_VISUAL_STATE_NONE);
		this:GetBrainManager():SetStateByName("Pain");
		m_doll:GetBrainManager():SetStateByName("Pain");
		m_hp = m_hp - damage;
		UpdateGUI();
		
		--//take over the brains of the player for a bit so he can't move for a bit
		local goal = this:GetGoalManager():PushNewGoal("DamageDelay");
		goal:PushDelay(500);
		
		--//visual effect of color flashing
		Schedule(1000, this:GetID(), 'this:GetBrainManager():Add("ColorFlash", "pulse_rate=50;a=-150;remove_brain_by_pulses=20");');
		m_invincibilityTimer = GetApp:GetGameTick()+2200;
	
end

function IsDead()
	return m_hp <= 0;
end

function OnHeal(healAmount)

		--//draw the floating # in green
	GetTextManager:AddCustom(tostring(healAmount), this, this:GetPos(), Vector2(0, -0.3), Color(0,200,0,255), 2000, C_FONT_DEFAULT);

	m_hp = m_hp + healAmount;
	m_hp = math.min(m_hp, m_max_hp); --//don't let us go over our max HP 
	
  UpdateGUI();

end

function OnEquip(name, weaponStrength)

	m_doll:RunFunction("ChangeWeapon", name, weaponStrength);
	this:Data():Set("HasWeapon", name);
	HasWeapon = name;
	this:Data():SetNum("WeaponDamage", weaponStrength);
	WeaponDamage = weaponStrength;

end

function SpellEquip(name, spell_mp)
	this:Data():Set("HasSpell", name);
	HasSpell = name;
	this:Data():SetNum("SpellCost", spell_mp);
	SpellCost = spell_mp;
	UpdateGUI();
end

function OnKill()
	
	--//make sure the sounds we used are off
	m_walkLoopingSound:Play(false);	
	m_climbLoopingSound:Play(false);	
	
	RemoveActivePlayerIfNeeded(this); --//let the engine know we shouldn't be the active player any more

end

function OnSave()
	LogMsg("Saving..");
		--//save to our permanent storage
	this:Data():SetNum("hp", m_hp);
	this:Data():SetNum("max_hp", m_max_hp);
	

	serialize_to_db(m_inventory, "inventory", this:Data());
end

function OnPickedUpCoin()

	local coinCount = this:Data():ModNum("coins", 1);

	UpdateGUI();

	
end

function GiveItem(name)
	AddItem(name, m_inventory);
	
end

function ProcessAction()

	m_bAction = false;

	--//first, check tiles we're touching
	
	local layerList = this:GetMap():GetLayerManager():GetVisibleLayers(); --//what layers we'll scan
	local tileList = this:GetMap():GetTilesByRect( Rect(this:GetWorldCollisionRect()), layerList, false); --//grab them

	--//LogMsg("Found " .. tileList:GetCount() .. " tiles after scanning the " .. layerList:GetCount() .. " layers.");

	local tile; 
	
	while true do
	
		tile = tileList:GetNext();
		if (tile == nil) then break; end;
		--//LogMsg("Found tile type " .. tile:GetType());
		
		if (tile:GetType() == C_TILE_TYPE_ENTITY and tile:GetAsEntity():GetID() != this:GetID()) then
			--//well, does this entity have a script, and if so, does it have a OnAction() function to handle
			--//us looking at them?
			if (tile:GetAsEntity():FunctionExists("OnAction")) then
				--//yay, it does
				--//it looks like it's prepared to handle our request that it "do something"
				tile:GetAsEntity():RunFunction("OnAction", this);
				return true;
			end
			
		end
	end
	

	--//let's try a totally different way, shooting rays out in front of us. "examine" things we're looking
	--//at, as the above method only checks what we're standing on.
	
	local rayRange = 80;
	local raySpread = 8; --//causes 8 rays to be shot in a spread formation, easier to detect hits.  0 to use 1 ray only
	local entToIgnore = this;
	local hitZone = this:GetMap():GetCollisionByRay(this:GetPos(), this:GetVectorFacing(), rayRange, raySpread, entToIgnore, C_RAY_ENTITIES, false);
		
	if (hitZone.entityID != C_ENTITY_NONE) then
		--//we have an entity in front of us!
		local ent = GetEntityByID(hitZone.entityID);
		
		if (ent:FunctionExists("OnAction")) then
			--//it looks like it's prepared to handle our request that it "do something"
			ent:RunFunction("OnAction", this);
			return true;
		end
	end
		
	--//they hit the action button and no entity was close
	 GetTextManager:Add("Hmm?", this);
end

function OnDialogCloseNotify(dialog) --//called on active player if it exists (dialog.lua)

	--//after a dialog is over, 
	
	this:Stop(); --//so we don't keep skidding around
	
	--//so they don't accidently swing/hit again right after the dialog because they had hit the keys

	ResetKeys()
	
end

function OnDialogOpenNotify(dialog) --//called on active player if it exists (dialog.lua)

	m_walkLoopingSound:Play(false);	
	m_climbLoopingSound:Play(false);

end
