function OnInit()

	this:SetVisualProfile("~/none/none.xml", "weapon");
	this:LoadCollisionInfo("~/none/none.col");
	m_parent = nil;
	m_canHit = false;
	this:SetCollisionCategories(C_CATEGORIES_NONE);
	this:SetCategory(C_CATEGORY_ENTITY, false);
	--this:SetCategory(C_CATEGORY_PLAYER, true);
	m_damagebase = nil;
	
end

function OnPostInit()
	this:SetDensity(0.2);
	this:SetPersistent(false); --//don't bother saving this	
	this:GetBrainManager():Add("StandardBase","");
	this:GetBrainManager():SendToBrainBase("control_filtery=0");	
	
end

function OnAttackLoop()

	this:SetCollisionListenCategory(C_CATEGORY_ENEMY, false);
	this:SetCollisionListenCategory(C_CATEGORY_ENTITY, false);
	
end

function SyncAnims(parent)
	m_parent = parent;
	this:SetFacing(parent:GetFacing());
	this:SetAnimFrame(parent:GetAnimFrame());	
end

function OnCollision(vPosition, vVelocity, vNormal, depth, materialID, entity, state)

	if (m_canHit == false or entity == nil) then
	  return;
	end
	
	if (entity:GetID() == m_parent:GetID()) then
		--//don't want to hurt ourself
	else
		--//LogMsg("Got hit by " .. tostring(ent:GetID()) .. " Depth: " .. tostring(depth) .. " normal: " .. tostring(normal));
	--//hurt this entity
  		entity:RunFunctionIfExists("OnDamage", vNormal, depth, m_parent, m_damagebase, 0, this);
	end
	
		--//by saying 1, we say run "on the next tick" as 1 MS is the smallest amount that can pass.
		Schedule(1, this:GetID(), "m_canHit = false;");

	return; --//don't allow collision to happen

end

function ChangeWeapon(name, weaponStrength)

	this:SetVisualProfile("~/"..name.."/"..name..".xml", "weapon");
	this:LoadCollisionInfo("~/"..name.."/"..name..".col");
	m_damagebase = weaponStrength;

end
